from pathlib import Path

from compile_asn import *

# A shortcut to avoid having to generate the compiler more than once
# Obviously a nasty global var, don't do this in production!
compiler = None
def getCompilerFor33128():
    global compiler
    if compiler is None:
        # You don't need to bother compiling all the ASN.1 files (including 33.108)
        # You only need the single 33.128 payload module
        moduleFiles = ['./testing/deps/33128/TS33128Payloads.asn']
        parseASN1Files(moduleFiles)
        # Similarly, the calls to fixedDottedReferences aren't needed, because
        # we aren't trying to fix the issues in compiling 33.108.
        # (I've added a flag to enable this shortcut - probably can be improved a lot more. Will think)
        err, compiler = compileASN1Files(moduleFiles, False)
    return compiler

def generateIRIPayload():
    compiler = getCompilerFor33128()

    iri = {
        'iRIPayloadOID': '0.4.19.15.0.3', 
        'event': ('pDUSessionModification', {
            'sUPI': ('iMSI', '99999000000000'), 
            'sUPIUnauthenticated': False, 
            'pEI': ('iMEISV', '2222222222222222'), 
            'gPSI': ('mSISDN', '491713920000'), 
            'sNSSAI': {'sliceServiceType': 1}, 
            'location': {'locationInfo': {
                'userLocation': {
                    'nRLocation': {
                        'tAI': {
                            'pLMNID': {
                                'mCC': '999', 
                                'mNC': '99'
                            }, 'tAC': b'222'
                        }, 
                        'nCGI': {
                            'pLMNID': {
                                'mCC': '99', 
                                'mNC': '2992'
                                }, 
                            'nRCellID': (bytearray(b'"""""'), 36)
                        }, 
                        'ageOfLocatonInfo': 0
                    }
                },
                'rATType' : 'nR',
                'timeZone': '+01:00+0'
                }   
            }, 
            'requestType' : 'modificationRequest',
            'accessType': 'threeGPPAccess',
            'rATType' : 'nR'
        })}

    b = compiler.encode('IRIPayload', iri)
    return b
